/******************************************************************

This program is made to verify Table 2 of paper, regime testing.

Jin Seo Cho

Sep. 12, 2004

*******************************************************************/

new;
library pgraph cml;
#include cml.ext;
CMLset;
_pdate = {0};

a = time;
proc lpr2(x, dta);
    local p1, the1, the2, the0, ss, nn, dep, ind;
    nn   = rows(dta);
    dep  = dta[2:nn,1];
    ind  = ones(nn-1,1)~dta[1:nn-1,1];
    the1 = zeros(2,1);
    the2 = zeros(2,1);
    the1[1,1] = x[1]; the1[2,1] = x[3];
    the2[1,1] = x[2]; the2[2,1] = x[3];
    ss   = x[4];
    p1   = x[5];
    retp( ln( p1 .* exp( lnpdfmvn(dep-ind*the1,ss) )
        + (1-p1) .* exp( lnpdfmvn(dep-ind*the2,ss) ) ) );
endp;

kkk = 3000;
nnn = 500;

/* Parameters for the DGP */
p1  = 0.9;
q1  = 1-p1;
rho = 0.5;
pp  = (1-q1)/(2-p1-q1);
trv = .4;

tes1 = zeros(kkk,8);
tes2 = zeros(kkk,3);

x1 = { -1.33 0. 0.5 1.0 0.01 };
x2 = { -0.66 0. 0.5 1.0 0.01 };
x3 = {  0.66 0. 0.5 1.0 0.01 };
x4 = {  1.33 0. 0.5 1.0 0.01 };

_title = "Estimation of mxiture model with 2 components";
_cml_DirTol = 0.001;
__output = 0;
_cml_Bounds = { -2 2,
                -2 2,
                 0 1, 
                .0 5.,
                .0 1. };

j = 1;
do until j > kkk;

    /* DGP: AR(1) */

    uuu = rndn(nnn,1);
    sss = rndu(nnn,1);
    xxx = zeros(nnn,1);
    xxx[1,1] = uuu[1,1]/sqrt(1-rho^2);
    iii = 2;
    do until iii > nnn;
        if sss[iii,1] < pp;
            xxx[iii,1] = -trv + rho * xxx[iii-1,1] + uuu[iii,1];
        else;
            xxx[iii,1] = trv + rho * xxx[iii-1,1] + uuu[iii,1];
        endif;
        iii = iii + 1;
    endo;

    /* Estimation */

    /* null model estimation */

    indv  = ones(nnn-1,1)~xxx[1:nnn-1,1];
    depv  = xxx[2:nnn,1];
    bhatn = inv(indv'*indv)*indv'*depv;
    uhatn = depv - indv*bhatn;
    shatn = vcx(uhatn);

    /* Initial parameter given by guess */

    /* alternative model estimation */

    {b1, h1, g, cov, ret} = CML(xxx, 0, &lpr2, x1);
    {b2, h2, g, cov, ret} = CML(xxx, 0, &lpr2, x2);
    {b3, h3, g, cov, ret} = CML(xxx, 0, &lpr2, x3);
    {b4, h4, g, cov, ret} = CML(xxx, 0, &lpr2, x4);

    h = zeros(4,1);
    h[1] = h1;
    h[2] = h2;    
    h[3] = h3;    
    h[4] = h4;    

    lhoodn = ln(  exp(-0.5*(depv-indv*bhatn)^2/shatn )/sqrt(2*pi*shatn) );
    tes2[j,1] = j/kkk;
    tes2[j,2] = 2 * ( maxc(h)*(nnn) - sumc(lhoodn) );
    print /flush j;
    j = j + 1;
endo;
  
b = time;

tes2[.,2] = sortc(tes2[.,2],1);

/* Theta = [-2.0, 2.0] w/ variance estimation */
tes_2p5 = (tes2[.,2] .> 7.0779381); 
tes_5p0 = (tes2[.,2] .> 5.6142656);
tes_7p5 = (tes2[.,2] .> 4.8670536); 
tes_10p = (tes2[.,2] .> 4.3352143); 

pow_2p5 = meanc(tes_2p5);
pow_5p0 = meanc(tes_5p0);
pow_7p5 = meanc(tes_7p5);
pow_10p = meanc(tes_10p);

print pow_10p;
print pow_7p5;
print pow_5p0;
print pow_2p5;

output file = table4_5thpn_2ndcol.txt reset;
screen off;
print tes2;
output off;
screen on;
